# Create your views here.
import os
import time
import cx_Oracle
from django.http import HttpResponse
from django.views.decorators.csrf import csrf_exempt
from rest_framework.renderers import JSONRenderer
from rest_framework.parsers import JSONParser
from rest_framework import status
from rest_framework.decorators import api_view
from rest_framework.response import Response
from campo_valor.models import Campo_Valor
from tablas.models import Tabla
from campo_valor.serializers import *
class JSONResponse(HttpResponse):
    """
    An HttpResponse that renders it's content into JSON.
    """
    def __init__(self, data, **kwargs):
        content = JSONRenderer().render(data)
        kwargs['content_type'] = 'application/json'
        super(JSONResponse, self).__init__(content, **kwargs)

#---Metodo para Modelo
@csrf_exempt
def campovalor_list(request):
    if request.method == 'GET':
        id_tabla = request.GET.get('id_tabla')
        contenedor=[]
        if id_tabla is None:
            actividades = Campo_Valor.objects.all().order_by('-nombre')
            for actividad in actividades:
                info={}
                info["id_campo_valor"]=actividad.id_campo_valor
                info["id_tabla"]=actividad.id_tabla.id_tabla
                info["nombre_tab"]=actividad.id_tabla.nombre
                info["nombre"]=actividad.nombre
                info["descripcion"]=actividad.descripcion
                contenedor.append(info)
        else:
            actividades = Campo_Valor.objects.filter(id_tabla=id_tabla).order_by('-nombre')
            for actividad in actividades:
                info={}
                info["id_campo_valor"]=actividad.id_campo_valor
                info["id_tabla"]=actividad.id_tabla.id_tabla
                info["nombre_tab"]=actividad.id_tabla.nombre
                info["nombre"]=actividad.nombre
                info["descripcion"]=actividad.descripcion
                contenedor.append(info)
        serializer = CampoValorSerializer(actividades, many=True)
        response={}
        total={}
        response['status']=0
        response['totalRows']=len(actividades)
        response['startRow']=0
        response['endRow']=len(actividades)-1
        response['data']=contenedor
        total['response']=response
        return JSONResponse(total)

    elif request.method == 'POST':
        id_tabla = request.POST.get('id_tabla')
        contenedor=[]
        if id_tabla is None:
            actividades = Campo_Valor.objects.all()
            for actividad in actividades:
                info={}
                info["id_campo_valor"]=actividad.id_campo_valor
                info["id_tabla"]=actividad.id_tabla.id_tabla
                info["nombre_tab"]=actividad.id_tabla.nombre
                info["nombre"]=actividad.nombre
                info["descripcion"]=actividad.descripcion
                contenedor.append(info)
        else:
            actividades = Campo_Valor.objects.filter(id_tabla=id_tabla)
            for actividad in actividades:
                info={}
                info["id_campo_valor"]=actividad.id_campo_valor
                info["id_tabla"]=actividad.id_tabla.id_tabla
                info["nombre_tab"]=actividad.id_tabla.nombre
                info["nombre"]=actividad.nombre
                info["descripcion"]=actividad.descripcion
                contenedor.append(info)
        serializer = CampoValorSerializer(actividades, many=True)
        response={}
        total={}
        response['status']=0
        response['totalRows']=len(actividades)
        response['startRow']=0
        response['endRow']=len(actividades)-1
        response['data']=contenedor
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def campovalor_ingresa(request):
    if request.method == 'GET':
        id_tabla = request.GET.get('id_tabla')
        nombre = request.GET.get('nombre')
        descripcion = request.GET.get('descripcion')
        tabla=Tabla.objects.get(id_tabla=id_tabla)
        a=Campo_Valor(id_tabla=tabla,nombre=nombre,descripcion=descripcion) 
        a.save() 
        conexiones = Campo_Valor.objects.get(id_campo_valor=a.id_campo_valor)
        serializer = CampoValorSerializer(conexiones)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)
    if request.method == 'POST':
        id_tabla = request.POST.get('id_tabla')
        nombre = request.POST.get('nombre')
        descripcion = request.POST.get('descripcion')
        tabla=Tabla.objects.get(id_tabla=id_tabla)
        a=Campo_Valor(id_tabla=tabla,nombre=nombre,descripcion=descripcion) 
        a.save() 
        conexiones = Campo_Valor.objects.get(id_campo_valor=a.id_campo_valor)
        serializer = CampoValorSerializer(conexiones)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def campovalor_actualiza(request):
    if request.method == 'GET':
        id_campo_valor=request.POST.get('id_campo_valor')
        id_tabla = request.POST.get('id_tabla')
        nombre = request.POST.get('nombre')
        descripcion = request.POST.get('descripcion')
        tabla=Tabla.objects.get(id_tabla=id_tabla)
        conexiones = Campo_Valor.objects.get(id_campo_valor=id_campo_valor)
        conexiones.id_tabla=tabla
        conexiones.nombre=nombre
        conexiones.descripcion=descripcion
        conexiones.save()
        serializer = CampoValorSerializer(conexiones)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)
    if request.method == 'POST':
        id_campo_valor=request.POST.get('id_campo_valor')
        id_tabla = request.POST.get('id_tabla')
        nombre = request.POST.get('nombre')
        descripcion = request.POST.get('descripcion')
        tabla=Tabla.objects.get(id_tabla=id_tabla)
        conexiones = Campo_Valor.objects.get(id_campo_valor=id_campo_valor)
        conexiones.id_tabla=tabla
        conexiones.nombre=nombre
        conexiones.descripcion=descripcion
        conexiones.save()
        serializer = CampoValorSerializer(conexiones)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def campovalor_elimina(request):
    if request.method == 'GET':
        id_conexion = request.GET.get('id_campo_valor')
        tabla = Campo_Valor.objects.get(id_campo_valor=id_conexion)
        tabla.delete()
        borro={}
        devuelve={}
        borro['id_campo_valor']=id_conexion
        devuelve['response']=borro
        return JSONResponse(devuelve)
    if request.method == 'POST':
        id_conexion = request.POST.get('id_campo_valor')
        tabla = Campo_Valor.objects.get(id_campo_valor=id_conexion)
        tabla.delete()
        borro={}
        devuelve={}
        borro['id_campo_valor']=id_conexion
        devuelve['response']=borro
        return JSONResponse(devuelve)
